<?php
/*
  $Id: west.php,v .10beta 2004/07/11 19:57:14 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class west {
    var $code, $title, $description, $enabled;

// class constructor
    function west() {
      global $order;

      $this->code = 'west';
      $this->title = MODULE_PAYMENT_WEST_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_WEST_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_WEST_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_WEST_STATUS == 'True') ? true : false);
	  
     //enable or disable the Western Union module
      if(MODULE_PAYMENT_WEST_STATUS == 'True'){
        if($_SESSION['cart']->total>MODULE_PAYMENT_WEST_MIN_AMOUNT){
          $this->enabled = true;
        }else{
          $this->enabled = false;
        }
      }else{
        $this->enabled = false;
      }

      if ((int)MODULE_PAYMENT_WEST_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_WEST_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    
      $this->email_footer = MODULE_PAYMENT_WEST_TEXT_EMAIL_FOOTER;
    }

// class methods
    function update_status() {
      global $order, $shipping;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_WEST_ZONE > 0) ) {
        $check_flag = false;
        $check_query = os_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_WEST_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = os_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
	  // disable if shipping is free - start
      if ($shipping['id']=="pickup_pickup") {
          $this->enabled = false;
        }
// disable if shipping is free - end
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return array('title' => MODULE_PAYMENT_WEST_TEXT_DESCRIPTION);
    }

    function process_button() {
      return false;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      return false;
    }

    function get_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = os_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WEST_STATUS'");
        $this->_check = os_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      os_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_WEST_STATUS', 'True', '6', '1', 'os_cfg_select_option(array(\'True\', \'False\'), ', now());");
		os_db_query("insert into ".TABLE_CONFIGURATION." ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_WEST_ALLOWED', '', '6', '0', now())");
      os_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_WEST_PAYTO', '', '6', '1', now());");
      os_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_WEST_EMAIL', '', '6', '1', now());");
      os_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_WEST_SORT_ORDER', '0', '6', '0', now())");
	  os_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_WEST_MIN_AMOUNT', '100', '6', '0', now())");
      os_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_WEST_ZONE', '0', '6', '2', 'os_get_zone_class_title', 'os_cfg_pull_down_zone_classes(', now())");
      os_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_WEST_ORDER_STATUS_ID', '0', '6', '0', 'os_cfg_pull_down_order_statuses(', 'os_get_order_status_name', now())");
    }

    function remove() {
      os_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_WEST_STATUS', 'MODULE_PAYMENT_WEST_ALLOWED', 'MODULE_PAYMENT_WEST_ZONE', 'MODULE_PAYMENT_WEST_ORDER_STATUS_ID', 'MODULE_PAYMENT_WEST_SORT_ORDER', 'MODULE_PAYMENT_WEST_PAYTO', 'MODULE_PAYMENT_WEST_EMAIL', 'MODULE_PAYMENT_WEST_MIN_AMOUNT');
    }
  }
?>
